import { EngineInterface } from '../types/engine';
import { Op, Path } from 'sharedb';
import { ApplierInterface, RemoteAttr, RemotePath } from '../types/ot';
import { NodeInterface } from '../types/node';
declare class Applier implements ApplierInterface {
    private engine;
    constructor(engine: EngineInterface);
    elementAtPath: (node: Node | NodeInterface, path: import("sharedb/lib/sharedb").Path) => [Node, undefined | number, Node, number];
    fromRemoteAttr(attr: RemoteAttr): {
        container: Node | null;
        offset: number;
    } | undefined;
    getSideText(node: NodeInterface, offset: number): RemoteAttr | undefined;
    setAttribute(path: Path, attr: string, value: string): void;
    removeAttribute(path: Path, attr: string): void;
    insertNode(path: Path, value: string | Op[] | Op[][]): void;
    deleteNode(path: Path, isRemote?: boolean): void;
    insertInText(path: Path, offset: number, text: string): void;
    deleteInText(path: Path, offset: number, text: string): void;
    applyOperation(op: Op, isRemote?: boolean): void;
    applyRemoteOperations(ops: Op[]): void;
    applySelfOperations(ops: Op[]): void;
    setRangeAfterOp(op: Op): void;
    getRangeRemotePath(): RemotePath | undefined;
    setRangeByRemotePath(path: RemotePath): void;
    setRangeByPath(path: Path[]): void;
}
export default Applier;
