/// <reference types="node" />
import { EventEmitter2 } from 'eventemitter2';
import { EngineInterface } from '../types/engine';
import { Op, Path, Doc } from 'sharedb';
import { NodeInterface } from '../types/node';
import { DocInterface } from '../types/ot';
declare class Creator extends EventEmitter2 {
    private engine;
    private doc?;
    private dmp;
    private addedNodes;
    private cacheTransientElements?;
    timer: NodeJS.Timeout | null;
    lineStart: boolean;
    laterOps: Op[] | null;
    constructor(engine: EngineInterface, options: {
        doc?: DocInterface | Doc;
    });
    patchesToOps(path: Path, text1: string, text2: string): (import("sharedb/lib/sharedb").StringInsertOp | import("sharedb/lib/sharedb").StringDeleteOp)[];
    cacheAddedNode(node: Node): void;
    clearAddedNodeCache(): void;
    inAddedCache(node: Node): Node | undefined;
    isTransientMutation(record: MutationRecord, transientElements?: Array<Node>): boolean;
    makeOpsFromMutations(records: MutationRecord[], path?: Path, oldPath?: Path, node?: NodeInterface): import("sharedb/lib/sharedb").Op[];
    getRemoveNodeIndex(record: MutationRecord, records: MutationRecord[]): number;
    getRemoveNodeIndexFromMutation(node: Node, target: Node, records: MutationRecord[]): number;
    handleMutations(records: MutationRecord[]): void;
    normalizeOps(ops: Op[]): void;
    setDoc(doc: DocInterface | Doc): void;
    readyToEmitOps(ops: any[]): void;
}
export default Creator;
