import { EventEmitter2 } from 'eventemitter2';
import { Doc, Op } from 'sharedb';
import { EngineInterface } from '../types/engine';
import { ApplierInterface, Attribute, Member, OTInterface, SelectionDataInterface } from '../types/ot';
import './index.css';
declare class OTModel extends EventEmitter2 implements OTInterface {
    private engine;
    private members;
    private currentMember;
    private waitingOps;
    private clientId;
    selectionData: SelectionDataInterface;
    private rangeColoring;
    applier: ApplierInterface;
    private mutation;
    private doc;
    constructor(engine: EngineInterface);
    private updateRangeColoringPosition;
    private applyWaitingOps;
    destroy(): void;
    initLockMode(): void;
    init(doc: Doc): void;
    handleOps(ops: Op[]): void;
    submitOps(ops: Op[]): void;
    applyAll(ops: Op[]): void;
    syncData(): void;
    setData(data: Array<any>): void;
    startMutation(): void;
    stopMutation(): void;
    startMutationCache(): void;
    submitMutationCache(): void;
    destroyMutationCache(): void;
    setMemberIdToUuid(member: Member): void;
    setMemberUuidToId(member: Member): void;
    setMemberColor(member: Member): void;
    getMembers(): Member[];
    setMembers(members: Array<Member>): void;
    addMember(member: Member): void;
    removeMember(member: Member): void;
    setCurrentMember(member: Member): void;
    getCurrentMember(): Member | undefined;
    doRangeColoring(attrs: Array<Attribute>, isDraw?: boolean): void;
    updateSelectionData(): void;
    initSelection(): void;
}
export default OTModel;
