/// <reference types="node" />
import { EventEmitter2 } from 'eventemitter2';
import { NodeInterface } from '../types';
import './index.css';
export declare type ScrollbarDragging = {
    point: number;
    position: number;
};
declare class Scrollbar extends EventEmitter2 {
    private container;
    private x;
    private y;
    private shadow;
    private scrollBarX?;
    private slideX?;
    private sildeXDragging?;
    private scrollBarY?;
    private slideY?;
    private slideYDragging?;
    private shadowLeft?;
    private shadowRight?;
    private oWidth;
    private oHeight;
    private sWidth;
    private sHeight;
    private xWidth;
    private yHeight;
    private maxScrollLeft;
    shadowTimer?: NodeJS.Timeout;
    /**
     * @param {nativeNode} container 需要添加滚动条的容器元素
     * @param {boolean} x 横向滚动条
     * @param {boolean} y 竖向滚动条
     * @param {boolean} needShadow 是否显示阴影
     */
    constructor(container: NodeInterface | Node, x?: boolean, y?: boolean, shadow?: boolean);
    init(): void;
    refresh(): void;
    bindEvents(): void;
    scrollX: (event: MouseEvent) => void;
    scrollY: (event: MouseEvent) => void;
    scrollXEnd: () => void;
    scrollYEnd: () => void;
    bindXScrollEvent: () => void;
    bindYScrollEvent: () => void;
    reRenderShadow: (width: number) => void;
    reRenderX: (left: number) => void;
    reRenderY: (top: number) => void;
}
export default Scrollbar;
